#define Uses_SCIM_IMENGINE
#define Uses_SCIM_ICONV
#define Uses_SCIM_CONFIG_BASE
#define Uses_SCIM_CONFIG_PATH

#include "scim.h"
#include "scim_fcitx_imengine.h"
using namespace scim;

#include <iconv.h>

#include "xim.h"

#include "tools.h"
#include "ime.h"

//#include "InputWindow.h"
#include "table.h"

//long            filter_mask = KeyPressMask | KeyReleaseMask;

Bool            bRunLocal = False;
char           *strDefaultLocale;
Bool            bUseCtrlShift = False;
Bool            bBackground = True;

KeyEvent  *Trigger_Keys = NULL;
INT8            iTriggerKeyCount;





/* Trigger Keys List */
static KeyEvent Trigger_Keys_Ctrl_Shift[] = {
  KeyEvent("Control+space"),
  KeyEvent("Mod4_Shift_L"),
  KeyEvent()
};

Bool IsKey (const KeyEvent &key, KeyEvent * trigger)
{			
  for (int i=0; !trigger[i].empty(); i++) {
    if (key == trigger[i])
      return true;
  }
  return key.empty(); //if key is empty:-)
}

void SendHZtoClient (FcitxInstance &fInst, char *strHZ)
{
	fInst.send_string(strHZ);
}

void EnterChineseMode (Bool bState)
{
    if (!bState) {
	ResetInput ();
//	ResetInputWindow ();

	if (im[iIMIndex].ResetIM)
	    im[iIMIndex].ResetIM ();
    }

//    DisplayMainWindow ();
}
